Index: trunk/LMDZ.MARS/README
===================================================================
--- trunk/LMDZ.MARS/README	(revision 607)
+++ trunk/LMDZ.MARS/README	(revision 608)
@@ -1587,3 +1587,5 @@
    dust_tes_MY25.nc and dust_tes_MY26.nc) scenarios by setting
    iaervar=124, 125 or 126 in callphys.def.
-   
+
+== 31/03/12 == AS & FF
+>> Deleted obsolete lines in solarlong   
Index: trunk/LMDZ.MARS/libf/phymars/physiq.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 607)
+++ trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 608)
@@ -1658,4 +1658,5 @@
       wco2ice(1:ngrid) = co2ice(1:ngrid)  !! co2 ice
       mtot(1:ngrid) = mtot(1:ngrid) * 1.e6 / rho_ice
+      icetot(1:ngrid) = icetot(1:ngrid) * 1.e6 / rho_ice
       !! JF 
       TAU_lay(:)=tau(:,1)!!true opacity (not a reference like tauref)
Index: trunk/LMDZ.MARS/libf/phymars/solarlong.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/solarlong.F	(revision 607)
+++ trunk/LMDZ.MARS/libf/phymars/solarlong.F	(revision 608)
@@ -61,9 +61,4 @@
 c -------------------------------------------------------
 
-c   Initialisation eventuelle:
-      if(.not.unitastr.gt.1.e-4) then
-         call iniorbit(249.22,206.66,669.,485.,25.2)
-      endif
-
 c  calcul de l'zanomalie moyenne
 
Index: trunk/MESOSCALE/LMD_MM_MARS/SIMU/RUN/save_this_simu
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SIMU/RUN/save_this_simu	(revision 607)
+++ trunk/MESOSCALE/LMD_MM_MARS/SIMU/RUN/save_this_simu	(revision 608)
@@ -34,5 +34,5 @@
 fi
 
-tar czvf def.tar.gz namelist.input namelist.wps callphys*.def makemeso* launch*
+tar czvf def.tar.gz namelist.input namelist.wps *.def makemeso* launch*
 cp def.tar.gz results/ 
 
Index: trunk/MESOSCALE_DEV/MANUAL/SRC/advance.tex
===================================================================
--- trunk/MESOSCALE_DEV/MANUAL/SRC/advance.tex	(revision 607)
+++ trunk/MESOSCALE_DEV/MANUAL/SRC/advance.tex	(revision 608)
@@ -141,3 +141,5 @@
 %% cas test THARSIS
 
+%% parler de diff_6th_opt = 0 obligatoire pour les cas avec traceurs
+
 \clearemptydoublepage
Index: trunk/MESOSCALE_DEV/NOTES.txt
===================================================================
--- trunk/MESOSCALE_DEV/NOTES.txt	(revision 607)
+++ trunk/MESOSCALE_DEV/NOTES.txt	(revision 608)
@@ -1,2 +1,11 @@
+
+si le systeme est sensible il vaut mieux r_aspect=1 et nsplit = 4 que
+r_aspect=0.7 et nsplit=2
+
+#nsplit_thermals = 2  !! BOF PAR RAPPORT A DEF 4
+#r_aspect_thermals = 1.0 !! MIEUX QUE DEF 0.7 si systeme sensible
+
+
+
 Mhh c'est un peu plus compliqué, car en toute rigueur il peut y avoir plusieurs traceurs poussières si on considère le cas où l'on tourne avec plusieurs bins radiativement actifs...
 
@@ -43,5 +52,4 @@
 
 
-quand on rajoute une variable dans Registry il faut absolument recompiler avec
 -f total. enlever Registry et faire Regitry.bash ne sufit pas. sinon il met un
 e erreur absurde avec le fait que les dx ne matchent pas.
Index: trunk/UTIL/PYTHON/planetoplot.py
===================================================================
--- trunk/UTIL/PYTHON/planetoplot.py	(revision 607)
+++ trunk/UTIL/PYTHON/planetoplot.py	(revision 608)
@@ -430,5 +430,11 @@
                    if len(what_I_plot.shape) == 3: itime=[0]
                    m = None ; x = None ; y = None
-                   what_I_plot, x, y = define_axis(lon,lat,vert,time,indexlon,indexlat,indexvert,\
+                   latyeah = lat ; lonyeah = lon
+                   if typefile in ['meso']:
+                       # now that the section is determined we can set the real lat
+                       # ... or for now, a temptative one.
+                       if slon is not None: latyeah = lat2d[:,0]
+                       if slat is not None: lonyeah = lon2d[0,:]
+                   what_I_plot, x, y = define_axis(lonyeah,latyeah,vert,time,indexlon,indexlat,indexvert,\
                          itime,what_I_plot, len(all_var[index_f].shape),vertmode)
                ###
@@ -491,6 +497,5 @@
                         if indextime is not None: lbl = lbl + " it" + str(indextime[0])
                         if lbl == "": lbl = namefiles[index_f]
-
-                        if lbls is not None: lbl=lbls[index_f]
+                        if lbls is not None: lbl=lbls[nplot-1]
 
                         if mrate is not None: x = y  ## because swapaxes...
@@ -548,5 +553,5 @@
                         zelevels = np.linspace(zevminc,zevmaxc,ticks/2) #20)
                         if var2 == 'HGT': zelevels = np.arange(-10000.,30000.,2000.)
-                        if mapmode == 0:    
+                        if mapmode == 0:   
                             what_I_plot_frame, x, y = define_axis( lon,lat,vert,time,indexlon,indexlat,indexvert,\
                                                               itime,what_I_plot_frame, len(all_var2[index_f].shape),vertmode )