Index: trunk/UTIL/PYTHON/myplot.py
===================================================================
--- trunk/UTIL/PYTHON/myplot.py	(revision 608)
+++ trunk/UTIL/PYTHON/myplot.py	(revision 610)
@@ -288,5 +288,5 @@
         subv = 2
         subh = 2
-        fig.subplots_adjust(wspace = 0.3, hspace = 0.3)
+        fig.subplots_adjust(wspace = 0.4, hspace = 0.3)
         rcParams['font.size'] = int( rcParams['font.size'] * 2. / 3. )
     elif numplot <= 6:
Index: trunk/UTIL/PYTHON/myscript.py
===================================================================
--- trunk/UTIL/PYTHON/myscript.py	(revision 608)
+++ trunk/UTIL/PYTHON/myscript.py	(revision 610)
@@ -38,5 +38,5 @@
     parser.add_option('--xlabel',       action='store',dest='xlab',       type="string",  default=None, help='customize the x-axis label')
     parser.add_option('--ylabel',       action='store',dest='ylab',       type="string",  default=None, help='customize the y-axis label')
-    parser.add_option('--labels',       action='store',dest='labels',     type="string",  default=None, help='customize 1D curve labels. String separated by commas. [None]')
+    parser.add_option('--labels',       action='store',dest='labels',     type="string",  default=None, help='customize 1D curve labels. Str comma-separated. [None]')
 
     ### SPECIFIC FOR MAPPING [MAPMODE 1]
Index: trunk/UTIL/PYTHON/planetoplot.py
===================================================================
--- trunk/UTIL/PYTHON/planetoplot.py	(revision 608)
+++ trunk/UTIL/PYTHON/planetoplot.py	(revision 610)
@@ -173,6 +173,6 @@
 ##########################################################
       if typefile in ["gcm","earthgcm","ecmwf"]:
-          if slon is not None: sslon = slon  ## a fix of the sslon not initialized. but what is the use of sslon?
-          if slat is not None: sslat = slat  ## a fix of the sslat not initialized. but what is the use of sslat?
+          if slon is not None: sslon = slon  
+          if slat is not None: sslat = slat  
           ### LAT
           if "latitude" in nc.variables:  lat = nc.variables["latitude"][:]
@@ -208,11 +208,11 @@
               else:                                                                           iwantawhereplot = None   #do not show anything, just select indices
               numlon = 1 ; numlat = 1 
-              if slon is not None:   numlon = slon.shape[0]    
-              if slat is not None:   numlat = slat.shape[0]
+              if slon is not None:   numlon = slon.shape[1]    
+              if slat is not None:   numlat = slat.shape[1]
               indices = np.ones([numlon,numlat,2]) ; vlon = None ; vlat = None
               for iii in range(numlon):  
                for jjj in range(numlat):
-                 if slon is not None:  vlon = slon[iii][0]  ### note: slon[:][0] does not work
-                 if slat is not None:  vlat = slat[jjj][0]  ### note: slon[:][0] does not work
+                 if slon is not None:  vlon = slon[0][iii]  ### note: slon[:][0] does not work
+                 if slat is not None:  vlat = slat[0][jjj]  ### note: slon[:][0] does not work
                  indices[iii,jjj,:] = bidimfind(lon2d,lat2d,vlon,vlat,file=iwantawhereplot)  
                  lonp,latp = ( lon2d[indices[iii,jjj,0],indices[iii,jjj,1]] , lat2d[indices[iii,jjj,0],indices[iii,jjj,1]] )
@@ -220,6 +220,6 @@
               for iii in range(numlon):
                for jjj in range(numlat):
-                 if slon is not None: sslon[iii][0] = indices[iii,0,1] ; sslon[iii][1] = indices[iii,0,1]  #...this is idx
-                 if slat is not None: sslat[jjj][0] = indices[0,jjj,0] ; sslat[jjj][1] = indices[0,jjj,0]  #...this is idy
+                 if slon is not None: sslon[0][iii] = indices[iii,0,1] #...this is idx
+                 if slat is not None: sslat[0][jjj] = indices[0,jjj,0] #...this is idy
               lonp,latp = ( lon2d[indices[0,0,0],indices[0,0,1]] , lat2d[indices[0,0,0],indices[0,0,1]] )
           ######
@@ -262,5 +262,6 @@
               if vertmode == 0:     vert = np.arange(0,getattr(nc,vertdim),1)
               elif vertmode == -1:  vert = nc.variables["PHTOT"][0,:,0,0]/3.72 ; vert = np.array(vert[0:len(vert)-1]) #; print vert
-              else:                 vert = nc.variables["vert"][:]
+              elif vertmode == 1 or vertmode == 2:  vert = nc.variables["vert"][:]        ## pressure in Pa
+              else:                                 vert = nc.variables["vert"][:]/1000.  ## altitude in km
        #if firstfile:
        #   lat0 = lat
Index: trunk/UTIL/PYTHON/pp.py
===================================================================
--- trunk/UTIL/PYTHON/pp.py	(revision 608)
+++ trunk/UTIL/PYTHON/pp.py	(revision 610)
@@ -79,10 +79,16 @@
             zelevel = float(inputnvert[0])
             ze_interp_levels = [-9999.]
-        elif np.array(inputnvert).size == 2:
+        elif np.array(inputnvert).size > 2:
             zelevel = -99.
-            ze_interp_levels = np.linspace(float(inputnvert[0]),float(inputnvert[1]),20)
-        else:
-            zelevel = -99.
-            ze_interp_levels = np.linspace(float(inputnvert[0]),float(inputnvert[1]),float(inputnvert[2]))
+            start = float(inputnvert[0])
+            stop = float(inputnvert[1])
+            if np.array(inputnvert).size == 2:  numsample = 20
+            else:                               numsample = float(inputnvert[2])
+            if stop > start:   
+               ## altitude coordinates
+               ze_interp_levels = np.linspace(start,stop,numsample)
+            else:
+               ## pressure coordinates
+               ze_interp_levels = np.logspace(np.log10(start),np.log10(stop),numsample)
 
         ######################################################### 