Index: trunk/LMDZ.MARS/libf/phymars/callradite.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callradite.F	(revision 626)
+++ trunk/LMDZ.MARS/libf/phymars/callradite.F	(revision 627)
@@ -132,5 +132,5 @@
 c fluxtop_sw(ngrid,2)       outgoing upward flux SW for solar band#2 (W.m-2)
 
-c   tauref       Prescribed mean column optical depth at 700 Pa 
+c   tauref       Prescribed mean column optical depth at 610 Pa 
 c   tau          Column total visible dust optical depth at each point
 c   aerosol(ngrid,nlayer,naerkind)    aerosol extinction optical depth
Index: trunk/LMDZ.MARS/libf/phymars/inifis.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/inifis.F	(revision 626)
+++ trunk/LMDZ.MARS/libf/phymars/inifis.F	(revision 627)
@@ -185,5 +185,5 @@
          write(*,*) " iaervar = ",iaervar
 
-         write(*,*) "Reference (visible) dust opacity at 700 Pa ",
+         write(*,*) "Reference (visible) dust opacity at 610 Pa ",
      &   "(matters only if iaervar=1)"
          ! NB: default value of tauvis is set/read in startfi.nc file
Index: trunk/LMDZ.MARS/libf/phymars/physiq.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 626)
+++ trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 627)
@@ -232,5 +232,6 @@
       REAL fluxtop_lw(ngridmx)       !Outgoing LW (IR) flux to space (W.m-2)
       REAL fluxtop_sw(ngridmx,2)     !Outgoing SW (solar) flux to space (W.m-2)
-      REAL tauref(ngridmx)           ! Reference column optical depth at 700 Pa
+      REAL tauref(ngridmx)           ! Reference column optical depth at odpref
+      real,parameter :: odpref=610. ! DOD reference pressure (Pa)
       REAL tau(ngridmx,naerkind)     ! Column dust optical depth at each point
       REAL zls                       !  solar longitude (rad)
@@ -603,10 +604,11 @@
 c          Outputs for basic check (middle of domain)
 c          ------------------------------------------
-           print*, 'Ls =',zls*180./pi,
-     &             'check lat lon', lati(igout)*180/pi,
-     &                              long(igout)*180/pi
-           print*, 'tauref(700 Pa) =',tauref(igout),
-     &             ' tau(700 Pa) =',tau(igout,1)*700./pplev(igout,1)
-
+           write(*,'("Ls =",f11.6," check lat =",f10.6,
+     &               " lon =",f11.6)')
+     &           zls*180./pi,lati(igout)*180/pi,long(igout)*180/pi
+           write(*,'(" tauref(",f4.0," Pa) =",f9.6,
+     &             " tau(",f4.0," Pa) =",f9.6)')
+     &            odpref,tauref(igout),
+     &            odpref,tau(igout,1)*odpref/pplev(igout,1)
 c          ---------------------------------------------------------
 c          Call slope parameterization for direct and scattered flux
@@ -1966,6 +1968,6 @@
       ELSE     ! if(ngrid.eq.1)
 
-         print*,'Ls =',zls*180./pi,
-     &  '  tauref(700 Pa) =',tauref
+         write(*,'("Ls =",f11.6," tauref(",f4.0," Pa) =",f9.6)')
+     &    zls*180./pi,odpref,tauref
 c      ----------------------------------------------------------------------
 c      Output in grads file "g1d" (ONLY when using testphys1d)
Index: trunk/LMDZ.MARS/libf/phymars/testphys1d.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 626)
+++ trunk/LMDZ.MARS/libf/phymars/testphys1d.F	(revision 627)
@@ -51,4 +51,6 @@
       INTEGER ilayer,ilevel,isoil,idt,iq
       LOGICAl firstcall,lastcall
+c
+      real,parameter :: odpref=610. ! DOD reference pressure (Pa)
 c
       INTEGER day0          ! date initial (sol ; =0 a Ls=0)
@@ -405,5 +407,5 @@
 c --------------------------------
       tauvis=0.2 ! default value for tauvis
-      print *,'Reference dust opacity at 700 Pa ?'
+      write(*,'("Reference dust opacity at ",f4.0," Pa ?")')odpref
       call getin("tauvis",tauvis)
       write(*,*) " tauvis = ",tauvis
@@ -627,10 +629,10 @@
          write(103,*) 'Ls=',zls*180./pi
          write(103,*) 'Lat=', lati(1)*180./pi
-         write(103,*) 'Tau=', tauvis/700*psurf
+         write(103,*) 'Tau=', tauvis/odpref*psurf
          write(103,*) 'RunEnd - Atmos. Temp. File'
          write(103,*) 'RunEnd - Atmos. Temp. File'
          write(104,*) 'Ls=',zls*180./pi
          write(104,*) 'Lat=', lati(1)
-         write(104,*) 'Tau=', tauvis/700*psurf
+         write(104,*) 'Tau=', tauvis/odpref*psurf
          write(104,*) 'RunEnd - Atmos. Temp. File'
         ENDIF